# SmallSense

*Developer's productivity plugin for Smalltalk/X IDE.*

## About

**SmallSense** is a set of tools that speed up development and make
Smalltalk programming even more fun. Features:

* **Code-completion** -- a fast code completion system for Smalltalk using both static and runtime type inference.
* **Syntax-driven editing** -- a nice little feature that helps you with editing and formatting the code, all syntax- and formater-preferences aware!
* **Instant static analysis** -- to detect & fix common errors and code smells as you type

There are many more features already on the TODO list :-) Besides, *SmallSense*
provides (limited) support for Java anf Groovy as well (to be used together with
[STX:LIBJAVA](https://swing.fit.cvut.cz/projects/stx-libjava))

## Installation

Just download and compile the package. Then, load the package into running Smalltalk/X IDE:

    Smalltalk loadPackage:'stx:goodies/smallsense'

*Note*: In [Smalltalk/X jv-branch](https://swing.fit.cvut.cz/projects/stx-jv), SmallSense is already included so no need to
download and load.

## Authors

Developers:

* Jan Vraný <jan . vrany [a] fir.cvut.cz>

Contributors:

* Jakub Zelenka (first version of code completion, type inference and syntax-error tolerant Smalltalk parser)

## License

The SmallSense is available under GNU Lesser General Public License.
Please find full text of the license in file license.txt.
For other licensing options, please contact the SmallSense author at
jan.vrany { at } fit.cvut.cz.







